> For the complete documentation index, see [llms.txt](https://docs.fortifiedid.se/access/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fortifiedid.se/access/key-components/authenticators/credential-validators/header-based/certificate.md).

# Certificate

This authenticator expects a configured HTTP header containing a X509 Certificate formatted as PEM.

## Configuration

{% hint style="info" %}
**Authenticator type:** `CertificateAuth`
{% endhint %}

Common Authenticator configuration can be found [here](/access/key-components/authenticators/common-configuration.md).

{% tabs %}
{% tab title="Properties" %}

<table data-full-width="true"><thead><tr><th>Name</th><th>Description</th><th>Default value</th><th data-type="checkbox">Mandatory</th></tr></thead><tbody><tr><td><code>certificate_header_name</code></td><td>Name of the headers containing the certificate.</td><td>N/A</td><td>true</td></tr><tr><td><code>missing_certificate_location</code></td><td>If the header contains no datat, where to redirect the client.</td><td>N/A</td><td>true</td></tr><tr><td><code>custom_identifier</code></td><td>When logging events, the custom_identifier lets you tag the event.</td><td>N/A</td><td>false</td></tr></tbody></table>
{% endtab %}

{% tab title="Example" %}

```json
{
            "id": "cert",
            "type": "CertificateAuth",
            "config": {
              "base_path": "/saml/authn",
              "certificate_header_name": "pemdata",
              "missing_certificate_location":"https://<custom_location>"
            }
}
```

{% endtab %}
{% endtabs %}

{% hint style="warning" %}
Property *base\_path* should not contain the full path when used in conjunction with the [Selector](/access/key-components/authenticators/flow-control/selector.md), instead, the full URI will be handled by the selector. The full path will be *base\_path + / + id*.
{% endhint %}

## Logging

Apart from system logging, event logging is done when starting, completing, and failing a transaction.

Event ids are:

* WEB\_100013("Authentication using certificate completed")
  * IDENTIFIER (user trace id)
  * SOURCE\_ADDRESS (ip address of device starting transaction)
  * CUSTOMER\_IDENTIFIER (if configured)
  * SOURCE\_USER\_NAME (subject from the certificate)
  * MESSAGE (certificate serial)

## Data exposed to global state

After a user completes a transaction, the authenticator is marked as done. Data from the authentication response is then put into the global state replacing existing values:

* serial
* subject
* certificate

## API

This authenticator has no UI


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fortifiedid.se/access/key-components/authenticators/credential-validators/header-based/certificate.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
